#ifndef EDITOR_H
#define EDITOR_H 1

#include <libgnomevfs/gnome-vfs.h>
#include <gtksourceview/gtksourcelanguage.h>
#include "world.h"

enum edit_type {
  E_EXTERNAL,
  E_MCP
};

enum editor_type {
  E_INTERN,
  E_EXTERN,
  E_VTE
};

typedef struct _editor_info {
  gchar *name;
  gchar *type;
  gchar *upload;

  enum edit_type etype;
  enum editor_type edtype;

  gboolean isCode;

  GList *lines;
  world *owner;

  GtkWidget *text;
  GtkWidget *child;

  gchar *filename;
  int pid;
  GnomeVFSMonitorHandle *filemon;

} editor_info;

void editor_invoke_mcp(world * wld, gchar * name, gchar * reference,
                       gchar * type, GList * lines);

void editor_invoke_oob(world * wld, gchar * line);
void editor_oob_end(world * wld);
void editor_oob_add(world * wld, gchar * line);
void editors_close(world * wld);
void editor_close(editor_info * e);
void editor_fini();
void editor_init();
GtkSourceLanguage *editor_get_language();

#endif
