#ifndef G_OPTIONS_H
#define G_OPTIONS_H

typedef struct _option option;

struct _option {
  gchar *key;
  gchar *value;
};

typedef struct _options options;

struct _options {
  gchar *filename;
  int optionCount;
  option **values;
};

void options_add(options * opt, char *key, char *value);
void options_set_str(options * opt, char *key, char *value);
char *options_get_str(options * opt, char *key);
void options_set_int(options * opt, char *key, int value);
int options_get_int(options * opt, char *key);

int options_exists(options * opt, char *key);

options *options_create();
void options_destroy();
void options_save(options * opt);
void options_load(options * opt, char *filename);

#endif
