#ifndef INTERFACE_H
#define INTERFACE_H

#include <gtk/gtk.h>
#include <glib.h>
#include <glade/glade.h>
#include "world.h"
#include "eggtrayicon.h"

enum {
  AUTOLOAD_COLUMN,
  NAME_COLUMN,
  N_COLUMNS
};

typedef struct _tray_info {
  EggTrayIcon *icon;
	GtkWidget *event_box;
	GtkWidget *image;
	GtkTooltips *tooltips;
	
	GtkWidget *popup_menu;
	GtkWidget *show_popup_item;
	GtkWidget *hide_popup_item;
	
	guint flash_timeout;
	gint iconnr;
} tray_info;

GtkWidget *create_wndMain();
GtkWidget *if_main_get_widget(gchar * name);

void interface_remove_world(world * wld);
void interface_update_world(world * wld);
GtkWidget *interface_add_world(world * wld);

void notebook_focus_with_label(GtkNotebook * note, gchar * caption);

GtkLabel *container_get_label(GtkContainer * cnt);
GtkMenuItem *get_menu_item_by_name(gchar * parent, gchar * name);

void interface_no_worlds_loaded();
void interface_worlds_loaded();

void if_main_update_connect_button(gboolean isConnected);

void tray_update();

#endif
