#ifndef MCP_PLAYERDB_H
#define MCP_PLAYERDB_H 1

#include "mcp.h"

typedef enum _playerdb_signal_type {
  SIG_ADD,
  SIG_SET,
  SIG_DEL
} playerdb_signal_type;

typedef struct _playerdb_player_info {
  gint id;
  GHashTable *values;
} playerdb_player_info;

typedef void(*playerdb_signal_func) (mcp_package *, playerdb_player_info *, 
                                     gchar *, gchar *);

typedef void(*playerdb_find_func) (playerdb_player_info *, gpointer user_data);
                                     
void mcp_playerdb_init(mcp_package *p);
void mcp_playerdb_fini(mcp_package *p);
void mcp_playerdb_simple(mcp_package * p, gchar * suffix, GList * fields);
gboolean mcp_playerdb_multi(mcp_package * p, gchar * data_tag, gchar * key,
                              gchar * value, GList * allValues);

gboolean mcp_playerdb_signal_connect(mcp_session *ses, playerdb_signal_type signal_type,
                                 gchar *key, playerdb_signal_func callback);
gboolean mcp_playerdb_signal_disconnect(mcp_session *ses, 
                                        playerdb_signal_func callback);
gchar *playerdb_get_prop(playerdb_player_info *ppi, gchar *key);
void playerdb_find_players_with(mcp_session *s, gchar *key, gchar *value, 
                                playerdb_find_func cb, gpointer user_data);

#endif
