#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#ifdef HASRUBY
  #ifndef SCRIPT_H
  #define SCRIPT_H

#  include <gtk/gtk.h>
#  include "world.h"

  typedef struct _script_function {
    gchar *name;
    gchar *fname;
    gchar *filename;
    gchar *description;
  } script_function;

  typedef struct _script_info {
    gchar *name;
    gchar *argstr;
  } script_info;

  void script_init();
  void script_fini();
  void script_flush_and_reload();
  void script_reload_file(const gchar *uri);
  gboolean script_add_file(const gchar *uri);
  void script_remove_file(const gchar *uri);
  
  script_function *script_find(gchar *name);
  gboolean script_run(world *wld, script_function *f, gchar *argstr);

  GList *script_get_scripts();
  GList *script_get_files();

  #endif
#endif
