#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <string.h>
#include <gtk/gtk.h>
#include <libgnome/libgnome.h>
#include <glib.h>
#include <vte/vte.h>

#include "debug.h"
#include "support.h"
#include "term.h"

void on_Term_window_title_changed(VteTerminal * vteterminal,
                                  gpointer user_data);

term_info *
term_create_widget(gchar * command) {
  term_info *result = g_new(term_info, 1);

  gchar *shell;
  gchar *cmd[4] = { NULL, NULL, NULL, NULL };

  result->inactive = 0;
  result->reColor = 0;

  result->widgets.term = vte_terminal_new();
  vte_terminal_set_font_from_string(VTE_TERMINAL(result->widgets.term),
                                    "monospace 8");
  vte_terminal_set_scroll_on_keystroke(VTE_TERMINAL(result->widgets.term),
                                       TRUE);
  vte_terminal_set_scrollback_lines(VTE_TERMINAL(result->widgets.term), 500);
  vte_terminal_set_scroll_on_output(VTE_TERMINAL(result->widgets.term), FALSE);
  vte_terminal_set_word_chars(VTE_TERMINAL(result->widgets.term),
                              "-A-Za-z0-9,./?%&#:_");
  vte_terminal_set_allow_bold(VTE_TERMINAL(result->widgets.term), TRUE);
  vte_terminal_set_audible_bell(VTE_TERMINAL(result->widgets.term), TRUE);
  gtk_widget_show(result->widgets.term);

  result->widgets.vscroll =
    gtk_vscrollbar_new(VTE_TERMINAL(result->widgets.term)->adjustment);
  gtk_widget_show(result->widgets.vscroll);

  result->widgets.hbox = gtk_hbox_new(FALSE, 6);

  gtk_box_pack_start(GTK_BOX(result->widgets.hbox), result->widgets.term, TRUE,
                     TRUE, 0);
  gtk_box_pack_end(GTK_BOX(result->widgets.hbox), result->widgets.vscroll,
                   FALSE, FALSE, 0);
  gtk_widget_show(result->widgets.hbox);

  shell = gnome_util_user_shell();

  if (!shell) {
    shell = g_strdup("/bin/sh");
  }

  cmd[0] = shell;

  if (command) {
    cmd[1] = "-c";
    cmd[2] = command;
  }

  vte_terminal_fork_command(VTE_TERMINAL(result->widgets.term), shell, cmd,
                            NULL, g_get_home_dir(), FALSE, TRUE, TRUE);
  g_free(shell);

  return result;
}
